// RTEQSharedMemorySampleDlg.cpp : implementation file
//
// created by Unwinder
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "RTEQSharedMemory.h"
#include "RTEQSharedMemorySample.h"
#include "RTEQSharedMemorySampleDlg.h"
/////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
/////////////////////////////////////////////////////////////////////////////
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}
/////////////////////////////////////////////////////////////////////////////
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}
/////////////////////////////////////////////////////////////////////////////
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CRTEQSharedMemorySampleDlg dialog
/////////////////////////////////////////////////////////////////////////////
CRTEQSharedMemorySampleDlg::CRTEQSharedMemorySampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRTEQSharedMemorySampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRTEQSharedMemorySampleDlg)
	m_strEventText		= _T("Event text");
	m_eventType			= 0;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}
/////////////////////////////////////////////////////////////////////////////
void CRTEQSharedMemorySampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRTEQSharedMemorySampleDlg)
	DDX_Text(pDX, IDC_EVENT_TEXT_EDIT, m_strEventText);
	DDV_MaxChars(pDX, m_strEventText, 255);
	DDX_Radio(pDX, IDC_APP_SPECIFIC_EVENT_RADIO, m_eventType);
	//}}AFX_DATA_MAP
}
/////////////////////////////////////////////////////////////////////////////
BEGIN_MESSAGE_MAP(CRTEQSharedMemorySampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRTEQSharedMemorySampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADD_EVENT_BUTTON, OnAddEventButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CRTEQSharedMemorySampleDlg message handlers
/////////////////////////////////////////////////////////////////////////////
BOOL CRTEQSharedMemorySampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	
	AddEvent("Sample started", FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}
/////////////////////////////////////////////////////////////////////////////
void CRTEQSharedMemorySampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
/////////////////////////////////////////////////////////////////////////////
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
/////////////////////////////////////////////////////////////////////////////
void CRTEQSharedMemorySampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
/////////////////////////////////////////////////////////////////////////////
HCURSOR CRTEQSharedMemorySampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CRTEQSharedMemorySampleDlg::AddEvent(LPCSTR lpText, BOOL bGlobal)
{
	BOOL bResult	= FALSE;
	HANDLE hMapFile = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, "RTEQSharedMemory");

	if (hMapFile)
	{
		LPRTEQ_SHARED_MEMORY pMapAddr = (LPRTEQ_SHARED_MEMORY)MapViewOfFile(hMapFile, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		
		if (pMapAddr && (pMapAddr->dwSignature == 'RTEQ'))
		{
			//create named mutex to prevent RTEQ shared memory access collisions with
			//other application as well as with RivaTuner itself

			HANDLE hMutex	= CreateMutex(NULL, FALSE, "Access_RTEQSharedMemory");
			WaitForSingleObject(hMutex, INFINITE);
	
			for (DWORD dwEntry=0; dwEntry<pMapAddr->dwEventArrSize; dwEntry++)
				//find first free entry in the queue

				//Note: the entry is treated as free if its' dwTime field is zero

			{
				//get ptr to current event descriptor entry

				//it is strongly recommended to use similar behavior in your code instead of accessing entries
				//arrays directly to ensure that your code will work even if entry size/format will change in
				//future versions

				RTEQ_SHARED_MEMORY::LPRTEQ_SHARED_MEMORY_EVENT_ENTRY pEntry = (RTEQ_SHARED_MEMORY::LPRTEQ_SHARED_MEMORY_EVENT_ENTRY)((LPBYTE)pMapAddr + pMapAddr->dwEventArrOffset + dwEntry * pMapAddr->dwEventEntrySize);

				if (!pEntry->dwTime)
					//check if the entry is free
				{
					//we've found free entry in the queue, so now we can store our event 

					pEntry->dwTime		= GetTickCount();
						//init event timestamp

					if (!bGlobal)
					{
						pEntry->dwProcessID	= GetCurrentProcessId();
							//init process ID
						GetModuleFileName(NULL, pEntry->szName, sizeof(pEntry->szName));
							//init module name
					}

					strncpy(pEntry->szText, lpText, sizeof(pEntry->szText) - 1);
						//init event text

					bResult = TRUE;
					break;
				}
			}

			ReleaseMutex(hMutex);
			CloseHandle(hMutex);
		
			UnmapViewOfFile(pMapAddr);
		}

		CloseHandle(hMapFile);
	}
	
	return bResult;
}
/////////////////////////////////////////////////////////////////////////////
void CRTEQSharedMemorySampleDlg::OnAddEventButton() 
{
	//copy text from controls to member variables
	UpdateData(TRUE);

	//add new event to the queue
	AddEvent(m_strEventText, m_eventType);

	//modify event text
	ModifyIndex(m_strEventText);

	//we've modified the event text, so now we must copy it from member
	//variable to edit control
	UpdateData(FALSE);
}
/////////////////////////////////////////////////////////////////////////////
// This helper function increments indices in in <text><index>-formatted 
// strings or adds indices to the strings formatted differently
/////////////////////////////////////////////////////////////////////////////
void CRTEQSharedMemorySampleDlg::ModifyIndex(CString& s)
{
	// get index of the first non-digit character starting from the end of string
	int i = strlen(s);
	while (i && isdigit(s.GetAt(i - 1))) 
		i--;

	// scan index from the end of the string 
	int j = 0;
	sscanf((LPCSTR)s + i, "%d", &j);

	// format new string by ripping old index and adding new one
	s.Format("%s%d", s.Left(i), j + 1);
}
/////////////////////////////////////////////////////////////////////////////
